unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, DB, Forms, Controls, Graphics, Dialogs, DBGrids, StdCtrls,
  Menus, ZConnection, ZDataset;

type

  { TForm1 }

  TForm1 = class(TForm)
    ButtonAktualisieren: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    EditDatabase: TEdit;
    EditHostname: TEdit;
    EditPort: TEdit;
    EditUser: TEdit;
    EditPassword: TEdit;
    LabelNotice: TLabel;
    LabelDatabase: TLabel;
    LabelHostname: TLabel;
    LabelPort: TLabel;
    LabelUser: TLabel;
    LabelPassword: TLabel;
    MenuItem1: TMenuItem;
    PopupMenu1: TPopupMenu;
    ZConnection1: TZConnection;
    ZQuery1: TZQuery;
    procedure ButtonAktualisierenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure ReadRunningSQLStatements();
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.ReadRunningSQLStatements();
begin
  ZConnection1.Connected   := false;
  ZConnection1.Protocol    := 'firebird-3.0';
  ZConnection1.User        := EditUser.Text;
  ZConnection1.Password    := EditPassword.Text;
  ZConnection1.Database    := EditDatabase.Text;
  ZConnection1.HostName    := EditHostname.Text;
  ZConnection1.Port        := StrToInt(EditPort.Text);
  ZConnection1.Connected   := true;
  DataSource1.DataSet      := ZQuery1;
  DBGrid1.DataSource       := DataSource1;
  ZQuery1.Connection       := ZConnection1;
  ZQuery1.SQL.Clear;
  ZQuery1.SQL.Text         := 'SELECT MON$STATEMENT_ID "Statement_ID", MON$TRANSACTION_ID "Transaction_ID", MON$ATTACHMENT_ID "Connection_ID", MON$STATE "State", MON$TIMESTAMP "Starttime", (CURRENT_TIMESTAMP - MON$TIMESTAMP)*24*60*60 "Runtime [sec]", CAST(MON$SQL_TEXT AS VARCHAR(4000)) "SQL-Statement" FROM MON$STATEMENTS WHERE MON$STATE >= 0';
  ZQuery1.Open;
  DBGrid1.AutoAdjustColumns;
end;

procedure TForm1.ButtonAktualisierenClick(Sender: TObject);
begin
  ReadRunningSQLStatements();
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ReadRunningSQLStatements();
end;

procedure TForm1.MenuItem1Click(Sender: TObject);
var
  SQLStmtOld:   String;

begin
  if (not(DataSource1.Dataset.FieldByName('STATEMENT_ID').IsNull)) and (not(DataSource1.Dataset.FieldByName('TRANSACTION_ID').IsNull)) then
  begin
    SQLStmtOld := ZQuery1.SQL.Text;
    ZQuery1.SQL.Text :=
    'DELETE FROM MON$STATEMENTS WHERE MON$STATEMENT_ID = ' + IntToStr(DataSource1.Dataset.FieldByName('Statement_ID').AsInteger) + LineEnding +
    'AND MON$TRANSACTION_ID = ' + IntToStr(DataSource1.Dataset.FieldByName('Transaction_ID').AsInteger) + LineEnding +
    'AND MON$ATTACHMENT_ID = '  + IntToStr(DataSource1.Dataset.FieldByName('Connection_ID').AsInteger) + ';';
    { This attempt with prepared statemnts is my favorite but doesnt work in this case, why?
    'DELETE FROM MON$STATEMENTS WHERE MON$STATEMENT_ID = :STATEMENT AND MON$TRANSACTION_ID = :TRANSACTION AND MON$ATTACHMENT_ID = :CONNECTION;';
    ZQuery1.ParamByName('STATEMENT').AsInteger   := DataSource1.Dataset.FieldByName('Statement_ID').AsInteger;
    ZQuery1.ParamByName('TRANSACTION').AsInteger := DataSource1.Dataset.FieldByName('Transaction_ID').AsInteger;
    ZQuery1.ParamByName('CONNECTION').AsInteger  := DataSource1.Dataset.FieldByName('Connection_ID').AsInteger;}
    ZQuery1.ExecSQL;
    ZQuery1.SQL.Text := SQLStmtOld;
    ZQuery1.Open;
    DBGrid1.AutoAdjustColumns;
  end;
  // wait a second so that the database gets time to remove the canceled SQL Statement
  sleep(1000);
  // make a refresh on SQL-Statements view
  ReadRunningSQLStatements();
end;

procedure TForm1.PopupMenu1Popup(Sender: TObject);
begin
  MenuItem1.Enabled :=
  (not DataSource1.Dataset.fieldByName('Statement_ID').IsNull)   and
  (not DataSource1.Dataset.fieldByName('Transaction_ID').IsNull) and
  (not DataSource1.Dataset.fieldByName('Connection_ID').IsNull)  and
  // only allow a delete on long running SQL Statements (State >= 2 = stalled, 1 = active, 0 = idle)
  // see https://ib-aid.com/download/docs/firebird-language-reference-2.5/fblangref-appx05-statements.html
  (DataSource1.Dataset.fieldByName('State').AsInteger >= 2);
end;

end.

